/* Core 2 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000-2010, 2012, 2014 Free Software Foundation,
Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of either:

  * the GNU Lesser General Public License as published by the Free
    Software Foundation; either version 3 of the License, or (at your
    option) any later version.

or

  * the GNU General Public License as published by the Free Software
    Foundation; either version 2 of the License, or (at your option) any
    later version.

or both in parallel, as here.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received copies of the GNU General Public License and the
GNU Lesser General Public License along with the GNU MP Library.  If not,
see https://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 64
#define GMP_LIMB_BYTES 8

/* 2133 MHz Core 2 (65nm) */
/* FFT tuning limit = 60000000 */
/* Generated by tuneup.c, 2014-03-13, gcc 4.5 */

#define MOD_1_NORM_THRESHOLD                 0  /* always */
#define MOD_1_UNNORM_THRESHOLD               0  /* always */
#define MOD_1N_TO_MOD_1_1_THRESHOLD          4
#define MOD_1U_TO_MOD_1_1_THRESHOLD          3
#define MOD_1_1_TO_MOD_1_2_THRESHOLD        11
#define MOD_1_2_TO_MOD_1_4_THRESHOLD        16
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD      9
#define USE_PREINV_DIVREM_1                  1  /* native */
#define DIV_QR_1_NORM_THRESHOLD              1
#define DIV_QR_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define DIV_QR_2_PI2_THRESHOLD           MP_SIZE_T_MAX  /* never */
#define DIVEXACT_1_THRESHOLD                 0  /* always (native) */
#define BMOD_1_TO_MOD_1_THRESHOLD           24

#define MUL_TOOM22_THRESHOLD                23
#define MUL_TOOM33_THRESHOLD                65
#define MUL_TOOM44_THRESHOLD               179
#define MUL_TOOM6H_THRESHOLD               268
#define MUL_TOOM8H_THRESHOLD               357

#define MUL_TOOM32_TO_TOOM43_THRESHOLD      69
#define MUL_TOOM32_TO_TOOM53_THRESHOLD     114
#define MUL_TOOM42_TO_TOOM53_THRESHOLD      73
#define MUL_TOOM42_TO_TOOM63_THRESHOLD      78
#define MUL_TOOM43_TO_TOOM54_THRESHOLD     100

#define SQR_BASECASE_THRESHOLD               0  /* always (native) */
#define SQR_TOOM2_THRESHOLD                 28
#define SQR_TOOM3_THRESHOLD                102
#define SQR_TOOM4_THRESHOLD                160
#define SQR_TOOM6_THRESHOLD                222
#define SQR_TOOM8_THRESHOLD                296

#define MULMID_TOOM42_THRESHOLD             28

#define MULMOD_BNM1_THRESHOLD               12
#define SQRMOD_BNM1_THRESHOLD               13

#define MUL_FFT_MODF_THRESHOLD             372  /* k = 5 */
#define MUL_FFT_TABLE3                                      \
  { {    372, 5}, {     17, 6}, {      9, 5}, {     19, 6}, \
    {     21, 7}, {     11, 6}, {     23, 7}, {     12, 6}, \
    {     25, 7}, {     21, 8}, {     11, 7}, {     25, 8}, \
    {     13, 7}, {     27, 8}, {     15, 7}, {     32, 8}, \
    {     17, 7}, {     36, 8}, {     19, 7}, {     40, 8}, \
    {     21, 9}, {     11, 8}, {     27, 9}, {     15, 8}, \
    {     35, 9}, {     19, 8}, {     41, 9}, {     23, 8}, \
    {     47, 9}, {     27,10}, {     15, 9}, {     43,10}, \
    {     23, 9}, {     51,11}, {     15,10}, {     31, 9}, \
    {     63,10}, {     39, 9}, {     83,10}, {     47, 9}, \
    {     95,10}, {     55,11}, {     31,10}, {     79,11}, \
    {     47,10}, {     95,12}, {     31,11}, {     63,10}, \
    {    127, 9}, {    255,10}, {    135, 9}, {    271,11}, \
    {     79,10}, {    159, 9}, {    319,10}, {    167,11}, \
    {     95,10}, {    191, 9}, {    383,10}, {    207,11}, \
    {    111,12}, {     63,11}, {    127,10}, {    271,11}, \
    {    143,10}, {    287, 9}, {    575,10}, {    303,11}, \
    {    159,10}, {    319,12}, {     95,11}, {    191,10}, \
    {    383,11}, {    207,10}, {    415,11}, {    223,13}, \
    {     63,12}, {    127,11}, {    271,10}, {    543,11}, \
    {    287,10}, {    575,11}, {    303,10}, {    607,12}, \
    {    159,11}, {    319,10}, {    639,11}, {    351,12}, \
    {    191,11}, {    415,12}, {    223,11}, {    479,13}, \
    {    127,12}, {    255,11}, {    543,12}, {    287,11}, \
    {    607,12}, {    319,11}, {    639,12}, {    351,11}, \
    {    703,13}, {    191,12}, {    415,11}, {    831,12}, \
    {    479,14}, {    127,13}, {    255,12}, {    607,13}, \
    {    319,12}, {    703,13}, {    383,12}, {    831,13}, \
    {    447,12}, {    959,14}, {    255,13}, {    511,12}, \
    {   1023,13}, {    575,12}, {   1215,13}, {    639,12}, \
    {   1279,13}, {    703,14}, {    383,13}, {    831,12}, \
    {   1663,13}, {    895,15}, {    255,14}, {    511,13}, \
    {   1151,14}, {    639,13}, {   1343,14}, {    767,13}, \
    {   1599,14}, {    895,15}, {    511,14}, {   1279,13}, \
    {   2687,14}, {   1407,13}, {   2815,15}, {    767,14}, \
    {   1535,13}, {   3199,14}, {   1663,13}, {   3455,16}, \
    {    511,15}, {   1023,14}, {   2047,13}, {   4095,14}, \
    {   2175,12}, {   8959,14}, {   2303,13}, {   4607,12}, \
    {   9471,14}, {   2431,13}, {   4863,12}, {   9983,15}, \
    {   1279,14}, {   2559,12}, {  10239,14}, {   2687,12}, \
    {  11775,15}, {   1535,14}, {   3327,13}, {   6655,14}, \
    {   3455,13}, {   6911,14}, {   3583,12}, {  14335,11}, \
    {  28671,10}, {  57343,11}, {   2048,12}, {   4096,13}, \
    {   8192,14}, {  16384,15}, {  32768,16}, {  65536,17}, \
    { 131072,18}, { 262144,19}, { 524288,20}, {1048576,21}, \
    {2097152,22}, {4194304,23}, {8388608,24} }
#define MUL_FFT_TABLE3_SIZE 183
#define MUL_FFT_THRESHOLD                 4736

#define SQR_FFT_MODF_THRESHOLD             340  /* k = 5 */
#define SQR_FFT_TABLE3                                      \
  { {    340, 5}, {     15, 6}, {      8, 5}, {     17, 6}, \
    {      9, 5}, {     19, 6}, {     23, 7}, {     12, 6}, \
    {     25, 7}, {     21, 8}, {     11, 7}, {     25, 8}, \
    {     13, 7}, {     27, 8}, {     15, 7}, {     31, 8}, \
    {     21, 9}, {     11, 8}, {     27, 9}, {     15, 8}, \
    {     33, 9}, {     19, 8}, {     41, 9}, {     23, 8}, \
    {     47, 9}, {     27,10}, {     15, 9}, {     43,10}, \
    {     23, 9}, {     55,10}, {     31, 9}, {     67,10}, \
    {     39, 9}, {     79,10}, {     47,11}, {     31,10}, \
    {     79,11}, {     47,10}, {     95,12}, {     31,11}, \
    {     63,10}, {    127, 9}, {    255, 8}, {    511, 9}, \
    {    271, 8}, {    543,11}, {     79, 9}, {    319, 8}, \
    {    639,11}, {     95,10}, {    191, 9}, {    383,10}, \
    {    207, 9}, {    415,12}, {     63,11}, {    127,10}, \
    {    271, 9}, {    543,10}, {    287, 9}, {    575,10}, \
    {    303, 9}, {    607,10}, {    319, 9}, {    639,11}, \
    {    175,12}, {     95,11}, {    191,10}, {    383,11}, \
    {    207,10}, {    415,13}, {     63,12}, {    127,11}, \
    {    271,10}, {    543,11}, {    287,10}, {    575,11}, \
    {    303,10}, {    607,11}, {    319,10}, {    639,11}, \
    {    351,12}, {    191,11}, {    415,10}, {    831,12}, \
    {    223,11}, {    447,10}, {    895,11}, {    479,13}, \
    {    127,12}, {    255,11}, {    543,12}, {    287,11}, \
    {    607,12}, {    319,11}, {    639,12}, {    351,13}, \
    {    191,12}, {    415,11}, {    831,12}, {    479,14}, \
    {    127,13}, {    255,12}, {    607,13}, {    319,12}, \
    {    703,13}, {    383,12}, {    831,13}, {    447,12}, \
    {    959,14}, {    255,13}, {    511,12}, {   1023,13}, \
    {    575,12}, {   1215,13}, {    639,12}, {   1279,13}, \
    {    703,14}, {    383,13}, {    831,12}, {   1663,13}, \
    {    959,15}, {    255,14}, {    511,13}, {   1087,12}, \
    {   2175,13}, {   1215,14}, {    639,13}, {   1343,12}, \
    {   2687,13}, {   1407,12}, {   2815,14}, {    767,13}, \
    {   1663,14}, {    895,15}, {    511,14}, {   1023,13}, \
    {   2175,14}, {   1151,13}, {   2303,12}, {   4607,13}, \
    {   2431,12}, {   4863,14}, {   1279,13}, {   2687,14}, \
    {   1407,15}, {    767,14}, {   1535,13}, {   3071,14}, \
    {   1663,13}, {   3455,12}, {   6911,14}, {   1791,13}, \
    {   3583,16}, {    511,15}, {   1023,14}, {   2175,13}, \
    {   4351,14}, {   2303,13}, {   4607,14}, {   2431,13}, \
    {   4863,15}, {   1279,14}, {   2815,13}, {   5631,14}, \
    {   2943,13}, {   5887,15}, {   1535,14}, {   3455,13}, \
    {   6911,14}, {  16384,15}, {  32768,16}, {  65536,17}, \
    { 131072,18}, { 262144,19}, { 524288,20}, {1048576,21}, \
    {2097152,22}, {4194304,23}, {8388608,24} }
#define SQR_FFT_TABLE3_SIZE 179
#define SQR_FFT_THRESHOLD                 3008

#define MULLO_BASECASE_THRESHOLD             0  /* always */
#define MULLO_DC_THRESHOLD                  62
#define MULLO_MUL_N_THRESHOLD             9174

#define DC_DIV_QR_THRESHOLD                 46
#define DC_DIVAPPR_Q_THRESHOLD             155
#define DC_BDIV_QR_THRESHOLD                50
#define DC_BDIV_Q_THRESHOLD                 94

#define INV_MULMOD_BNM1_THRESHOLD           48
#define INV_NEWTON_THRESHOLD               156
#define INV_APPR_THRESHOLD                 155

#define BINV_NEWTON_THRESHOLD              234
#define REDC_1_TO_REDC_2_THRESHOLD          22
#define REDC_2_TO_REDC_N_THRESHOLD          48

#define MU_DIV_QR_THRESHOLD               1187
#define MU_DIVAPPR_Q_THRESHOLD            1142
#define MUPI_DIV_QR_THRESHOLD               74
#define MU_BDIV_QR_THRESHOLD              1017
#define MU_BDIV_Q_THRESHOLD               1187

#define POWM_SEC_TABLE  1,64,131,269,466

#define MATRIX22_STRASSEN_THRESHOLD         19
#define HGCD_THRESHOLD                     117
#define HGCD_APPR_THRESHOLD                151
#define HGCD_REDUCE_THRESHOLD             2121
#define GCD_DC_THRESHOLD                   427
#define GCDEXT_DC_THRESHOLD                342
#define JACOBI_BASE_METHOD                   4

#define GET_STR_DC_THRESHOLD                11
#define GET_STR_PRECOMPUTE_THRESHOLD        18
#define SET_STR_DC_THRESHOLD               552
#define SET_STR_PRECOMPUTE_THRESHOLD      1561

#define FAC_DSC_THRESHOLD                  656
#define FAC_ODD_THRESHOLD                   23
